#!c:/perl/bin/perl -w

# parametri per PERLIDE D:\aggiornaPL\aggiornapl_w.ini RedDiscoD


#
# aggiornaPL.pl (by) Sommaruga Andrea Guido - http://sommaruga.stnet.net
#
# History:
# 04-10-2004  v.0.1     - attivata in mangiavacchi
# 31-01-2005  v.0.2     - attivato cancellazione orfani
# 24-05-2005  v.0.3     - aggiunto parametri da linea di comando +
#                         cambiato ctime in mtime nel test per aggiornamento
# 08-06-2005  v.0.4     - test trgscan/cancellafile/cancelladir
# 22-01-2007  v.0.4.1   - aggiunto test nul list in copia file
# 22-03-2007  v.0.5     - revisionato struttura log e rimozione file 
# 22-03-2007  v.0.51    - piccole correzioni formali
# 23-03-2007  v.0.6     - modificato passaggio parametri: richiede un file .INI
#                         il nome del file .INI pu essere passatto su linea di comando
# 23-03-2007  v.0.6.1   - Abbellimenti ai log
# 24-03-2007  v.0.6.2   - corretto creazione script cancellazione sost ' con \'
# 24-03-2007  v.0.6.3   - modificato script cancellazione dir e file
# 25-03-2007  v.0.6.4   - modificato script cancellazione file: corretto ricorsione direttori in cancellafile
# 16-09-2007  v.0.6.5   - aggiunto file::path per la funzione rmtree
# 13-10-2007  v.0.6.6   - aggiunto riepilogo al file di LOG
# 17-04-2008  v.0.6.7   - aggiunto test sia data che dimensione per decidere copia
# 29-04-2008  v.0.6.8   - modifiche varie alla logica di controllo con stat()
# 04-06-2008  v.0.6.9   - corretto chiamata ad printtolog errata alla 437 nel passaggio variabili
# 08-11-2008  v.0.6.11  - aggiunto visualizzazione in cancellazioni
# 03-02-2009  v.0.6.12  - modificato test date aggiunto scarto di 60 secondi
# 15-12-2008  v.0.8.0   - aggiunto generazione dei PDF per segnalare le modifiche
# 18-02-2009  v.0.8.1   - aggiunto dichiarazione esplicita per text::PDF richiesto da PDF::Reuse
# 21-02-2009  v.0.9.0   - corretto generazione nome pdf ed aggiunto cancellazione file automatica
# 24-11-2009  v.0.9.1   - aggiunto controllo correttezza inifile
# 24-11-2011  v.0.9.2   - aggiunto LOG_MD5 e LOG_IGNORE + cambiato test per vedere se copiare
# 06-11-2011  v.0.9.3   - varie modifiche al ciclo di aggiornamento
# 06-11-2011  v.0.9.4   - aggiunto blacklist
# 26-04-2012  v.0.9.5   - modificato test su mtime assumendo come non piu' recenti tutti i file con differenza di max 10 secondi
# 18-05-2012  v.0.9.6   - corretto test se da aggiornare che dava errori
# 26-11-2014  v.0.9.6a  - correzioni estetiche di formattazione
# 27-11-2014  v.0.9.7   - aggiunto DEBUG
# 29-11-2014  v.0.9.8   - aggiunto ANSIcolor
# 11-02-2016  v.0.9.8.1 - cambiato colori
# 23-03-2016  v.0.9.8.1d- aggiunto debug recursive
# 15-11-2016  v.1.0.0   - aggiunta delle versioni con struttura ghost parallela
# 17-11-2016  v.1.0.0.1 - modifiche estetiche al sorgente (per compilarlo con Strawberry perl x64
# 19-11-2016  v.1.1.0   - Sistemato exclude dir + modificato sezioni inifile
# 22-11-2016  v.1.1.1   - Corretto baco, non deve creare la versione se si tratta di un file nuovo
# 15-04-2017  v.1.1.2   - Aggiunge messaggio copy file... 
#       ATTENZIONE: CORREGGERE sempre la variavile versione piu sotto!!


# TODO:
#       test di esclusione . e .. da correggere
#       controllare valori resi da stat()
#       unificare le chiamate glob() - dir in unica funzione che fa tutto
#

# ==================================================================
# struttura resa da stat()
# ------------------------------------------------------------------
#  0 dev      device number of filesystem
#  1 ino      inode number
#  2 mode     file mode  (type and permissions)
#  3 nlink    number of (hard) links to the file
#  4 uid      numeric user ID of file's owner
#  5 gid      numeric group ID of file's owner
#  6 rdev     the device identifier (special files only)
#  7 size     total size of file, in bytes
#  8 atime    last access time in seconds since the epoch
#  9 mtime    last modify time in seconds since the epoch
# 10 ctime    inode change time in seconds since the epoch (*)
# 11 blksize  preferred block size for file system I/O
# 12 blocks   actual number of blocks allocated
#
# debug vari dopo lo stat(nomefile)
# ------------------------------------------------------------------
#    print  "Leggibile\n" if -r _;
#    print  "Scrivibile\n" if -w _;
#    print  "Eseguibile\n" if -x _;
#    print  "Setuid\n" if -u _;
#    print  "Setgid\n" if -g _;
#    print  "Sticky\n" if -k _;
#    print  "Testo\n" if -T _;
#    print  "File binario\n" if -B _;
# ==================================================================


# -----------------------------------------------
# Sintassi per inifile
# 
#   ; this is a comment
#
#   [SectionName]
#   keyname=value
#   keyname=value, value, value ;comment
# -----------------------------------------------



# ========================================================================================
# richiede i moduli
# ----------------------------------------------------------------------------------------
#        Mail::Sendmail
#        Config::IniFiles 
#        Filesys::DfPortable
#        Date::Simple
#	 PDF-Reuse
#        Text-PDF
#        Font-TTF
#
#        --- per correggere un baco di utime con win32 serve il prox modulo ---
#        Win32API::File::Time                     (Win32API-File-Time) 
# ----------------------------------------------------------------------------------------
# Metodi di installazione dei moduli
#
#    da perl:           perl -MCPAN -e "install Mail::Sendmail"
#    manuale:           Copy Sendmail.pm to Mail/ in your Perl lib directory.
#    ActivePerl's PPM:  ppm install --location=http://alma.ch/perl/ppm Mail-Sendmail
# ========================================================================================
#
# ATTENZIONE: non usare il modulo by name, ha un funzionamento strano
#
#use File::stat;
# modulo per usare $sb = stat($nomefile);    $sb->size  $sb->mtime   ecc.

# costanti per ansi color
# ------------------------------------------------------------
# es:   print BOLD BLUE ON_WHITE "Text", RESET, "\n";
# ------------------------------------------------------------
#  1 CLEAR           RESET             BOLD            DARK
#  2 FAINT           ITALIC            UNDERLINE       UNDERSCORE
#  3 BLINK           REVERSE           CONCEALED
#  4
#  5 BLACK           RED               GREEN           YELLOW
#  6 BLUE            MAGENTA           CYAN            WHITE
#  7 BRIGHT_BLACK    BRIGHT_RED        BRIGHT_GREEN    BRIGHT_YELLOW
#  8 BRIGHT_BLUE     BRIGHT_MAGENTA    BRIGHT_CYAN     BRIGHT_WHITE
#  9
#  10 ON_BLACK        ON_RED            ON_GREEN        ON_YELLOW
#  11 ON_BLUE         ON_MAGENTA        ON_CYAN         ON_WHITE
#  12 ON_BRIGHT_BLACK ON_BRIGHT_RED     ON_BRIGHT_GREEN ON_BRIGHT_YELLOW
#  13 ON_BRIGHT_BLUE  ON_BRIGHT_MAGENTA ON_BRIGHT_CYAN  ON_BRIGHT_WHITE

use strict;
use File::DosGlob;
use Digest::MD5;
use Mail::Sendmail 0.79;
use Config::IniFiles;
use Win32API::File::Time  qw{utime};
use PDF::Reuse;
use Text::PDF;      					# richiesto da PDF::Reuse per TTFont0
use Font::TTF;	    					# richiesto da Text::PDF
use Filesys::DfPortable;
use File::Copy;
use File::Path qw(make_path remove_tree);
use Date::Simple;
#use Date::Format;
use POSIX::strftime::Compiler  qw/strftime/;
use File::Path;
use File::Basename;
use File::Basename::Extra qw(basename basename_nosuffix basename_suffix dirname fullname_suffix fullname_nosuffix);
use Win32::Console::ANSI;
use Term::ReadKey;
use Term::ANSIColor qw(:constants);
use Win32::Console::ANSI qw/ Title /;
use Win32::Console::ANSI qw/ :SW_ /;
use Win32::Console::ANSI qw( Cls Cursor Title XYMax SetConsoleSize);
use Win32::Console;

# ************************************
#
# --- dichiarazione costanti
#
# ************************************
use constant MSG_UPDATE => 'Update';
use constant MSG_COPY =>   'Copy';
use constant MSG_DELETE => 'Delete';
use constant MSG_IGNORE => 'Ignore';
use constant MSG_ERROR => 'Error';
use constant MSG_RECENT => 'Recent';

# ************************************
#
# --- autoflush per STDOUT per stampare immediatamente con \r
#
# ************************************
use IO::Handle; STDOUT->autoflush;
local $| = 1;

# ---------------------------------------------------------
# .........................................................
#	Variabile che indica la versione dello script
# .........................................................
# ---------------------------------------------------------
my $versione = 'v.1.1.2';

my $base_dir  = 'd:/usr/jobs/';				# deve finire con /
my $trg_dir   = 'e:/tmp/aggiorna/test/';	# deve finire con /
my $ghost_dir = 'e:/tmp/aggiorna/ghost/';	# deve finire con /$log_dir   = '
my $log_dir   = 'e:/tmp/aggiorna/log/';		# deve finire con /
my $log_name  = 'test';
my $flg_md5        = 0;						# 1=attivo controll
my $flg_email      = 0;						# 1=attivo emailmy o Md5
my $flg_ignoredata = 0;						# 1=ignoro data destinazione
my $flg_delete     = 0;						# 1=cancella file orfani e dir orfani 
my $flg_ghost      = 1;             		# 1=attiva controllo versioni
my $cfg          = '';						# legge i parametri dal file .ini
my $inifile      = 'aggiornaPl.ini';		# se non passo la sezione come parametro assumo la sezione GENERICA
my $inisection   = 'generica';			    # se non passo la sezione come parametro assumo la sezione GENERICA
my $fileblacklist= '(Thumbs\.db|\.bak|\.tbk|\.~tmp|\.~doc)$';
my $dirblacklist = '(Recycle\.Bin|System\sVolume\sInformation)';
my $debug        =0;	  					# 1=debug attivo           

# variabili per inviare la mail riepilogativa
my $mail_to       = '';
my $mail_from     = '';
my $mail_cc       = '';
my $mail_subject  = '';
my $mail_smtp     = '';
my $mail_username = '';
my $mail_password = '';
my $mail_txt      = '';
my $recursivecall = 0;

# dimensiona la finestra
if ( SetConsoleSize( 132, 43 ) != 0 ) {
    SetConsoleSize( 80, 25 );
}

my $STDIN = new Win32::Console(STD_INPUT_HANDLE);
$STDIN -> Mode(ENABLE_PROCESSED_INPUT);


# =======================================================================================
#
# controlla se  stato passato da linea di comando il file .INI dei parametri
# se non  stato passato controlla se esiste il file .INI di default aggiornaPl.ini
# $ARGV[0] -> valore primo elemento passato
# $#ARGV   -> indice ultimo elemento
# @ARGV    -> array
#
# =======================================================================================

if ($#ARGV == 1) {
    $inifile = $ARGV[0];
    $inisection = $ARGV[1];
    
    # verifica che il file .INI esista
    testfile ($inifile, 1);
    
    $cfg = new Config::IniFiles( -file => $inifile , -nocase => 1 );
    if (! defined $cfg ) {
		print "**** ERRORE nel file INI ****  @Config::IniFiles::errors\n";
		die;
    }
	
    # ****************************************************
    # se mancano delle sezioni/valori...le aggiunge
    # per la gestione dei vecchi inifile  
    # ****************************************************
    {
		my $flg_rewrite = 0;
		if (! $cfg->exists('comune', 'fileblacklist')) {
			$cfg->newval('comune', 'fileblacklist', '(Thumbs\.db|\.ntx|\.bak|\.tbk|\.~tmp|\.~doc)$');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'dirblacklist')) {
			$cfg->newval('comune', 'dirblacklist', '(Recycle\.Bin|System\sVolume\sInformation)');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'debug')) {
			$cfg->newval('comune', 'debug', '0');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'flg_ignoredata')) {
			$cfg->newval('comune', 'flg_ignoredata', '0');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'flg_delete')) {
			$cfg->newval('comune', 'flg_delete', '0');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'flg_md5')) {
			$cfg->newval('comune', 'flg_md5', '0');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'flg_ghost')) {
			$cfg->newval('comune', 'flg_ghost', '0');
			$flg_rewrite = 1;
		}
		if (! $cfg->exists('comune', 'ghost_dir')) {
			$cfg->newval('comune', 'ghost_dir', '');
			$flg_rewrite = 1;
		}
		if ( $flg_rewrite == 1 ) {
			$cfg->WriteConfig($inifile);
		}
    }
    
    # legge i valori
    $log_dir        = $cfg->val( $inisection, 'log_dir' );
    $log_name       = $cfg->val( $inisection, 'log_prefix' );
    $base_dir       = $cfg->val( $inisection, 'src_dir' );
    $trg_dir        = $cfg->val( $inisection, 'trg_dir' );
    $mail_txt       = $cfg->val( $inisection, 'mail_txt' );

	# legge valori comuni sovrascrivibili localmente
    $ghost_dir      = $cfg->val( $inisection, 'ghost_dir' )?      $cfg->val( $inisection, 'ghost_dir' ):      $cfg->val( 'comune', 'ghost_dir' );
    $flg_ghost      = $cfg->val( $inisection, 'flg_ghost' )?      $cfg->val( $inisection, 'flg_ghost' ):      $cfg->val( 'comune', 'flg_ghost' );
    $flg_ignoredata = $cfg->val( $inisection, 'flg_ignoredata' )? $cfg->val( $inisection, 'flg_ignoredata' ): $cfg->val( 'comune', 'flg_ignoredata' );
    $flg_delete     = $cfg->val( $inisection, 'flg_delete' )?     $cfg->val( $inisection, 'flg_delete' ):     $cfg->val( 'comune', 'flg_delete' );
    $flg_md5        = $cfg->val( $inisection, 'flg_md5' )?        $cfg->val( $inisection, 'flg_md5' ):        $cfg->val( 'comune', 'flg_md5' );
    
	# debug 
    $debug          = $cfg->val( $inisection, 'debug' )? $cfg->val( $inisection, 'debug' ): $cfg->val( 'comune', 'debug' );
	
	# blacklist
    $fileblacklist  = $cfg->val( $inisection, 'fileblacklist' )? $cfg->val( $inisection, 'fileblacklist' ): $cfg->val( 'comune', 'fileblacklist' );
    $dirblacklist   = $cfg->val( $inisection, 'dirblacklist' ) ? $cfg->val( $inisection, 'dirblacklist' ) : $cfg->val( 'comune', 'dirblacklist' );

    # parametri per invio email   
    $mail_to       = $cfg->val( 'comune', 'mail_to' );               
    $mail_from     = $cfg->val( 'comune', 'mail_from' );               
    $mail_subject  = $cfg->val( 'comune', 'mail_subject' );               
    $mail_cc       = $cfg->val( 'comune', 'mail_cc' );               
    $mail_smtp     = $cfg->val( 'comune', 'mail_smtp' );
    $mail_username = $cfg->val( 'comune', 'mail_username' );
    $mail_password = $cfg->val( 'comune', 'mail_password' );
    $flg_email     = $cfg->val( $inisection, 'flg_email' )? $cfg->val( $inisection, 'flg_email' ): $cfg->val( 'comune', 'flg_email' );
	
    # per compatibilit con vecchi inifile...se non previsto lo aggiungo a falso

}   
    

# $all_file, $src_dir e $trg_dir sono globali!
my $src_dir  = $base_dir;

my $all_file     = $log_dir . $log_name . '.all.csv';
my $err_file     = $log_dir . $log_name . '.err.csv';
my $copy_file    = $log_dir . $log_name . '.cpy.csv';
my $ignore_file  = $log_dir . $log_name . '.ignore.csv';
my $md5_file     = $log_dir . $log_name . '.md5.csv';
my $recent_file  = $log_dir . $log_name . '.recent.csv';
my $debug_file   = $log_dir . $log_name . '.debug.csv';
my $ghost_file   = $log_dir . $log_name . '.ghost.csv';
my $del_script   = $log_dir . $log_name . '.deletescript.pl';       # script di delete per i file (perl)
my $bat_script   = $log_dir . $log_name . '.deletescript.bat';      # script di delete per i file bat

my $err_cnt  = 0;                           # conteggio errori
my $copy_cnt = 0;                           # conteggio file copiati
my $upd_cnt  = 0;                           # conteggio file aggiornati
my $dir_cnt  = 0;                           # conteggio direttori creati
my $ignore_cnt  = 0;                        # conteggio file ignorati perch pi recenti sul trg
my $delete_cnt  = 0;			    		# conteggio righe dir/file da cancellare
my $recent_cnt  = 0;			    		# conteggio file pi recenti sulla destinazione
my $copy_size = 0;                          # dimensione file copiati
my $upd_size  = 0;                          # dimensione file aggiornati
my $forceupd_cnt = 0;                       # file aggiornati forzatamente: date diverse ma md5 uguale

my %mail;
my $bodymail;

#
# esegue i test sui file di controllo
#
# testfile ( $src_dir.'scandir.src', 1)
# testfile ( $trg_dir.'scandir.trg', 1)

# crea i file di log:
open LOG_ALL,        '>', $all_file     or die "Non posso aprire $all_file:  $!";
open LOG_ERR,        '>', $err_file     or die "Non posso aprire $err_file:  $!";
open LOG_COPY,       '>', $copy_file    or die "Non posso aprire $copy_file: $!";
open LOG_IGNORE,     '>', $ignore_file  or die "Non posso aprire $ignore_file:  $!";
open LOG_RECENT,     '>', $recent_file  or die "Non posso aprire $recent_file:  $!";
open LOG_MD5,        '>', $md5_file     or die "Non posso aprire $md5_file:  $!";
open LOG_DELSCRIPT,  '>', $del_script   or die "Non posso aprire $del_script:  $!";
open LOG_BATSCRIPT,  '>', $bat_script   or die "Non posso aprire $bat_script:  $!";
open LOG_DEBUG,      '>', $debug_file   or die "Non posso aprire $debug_file:  $!";
open LOG_GHOST,      '>', $ghost_file   or die "Non posso aprire $ghost_file:  $!";

# ********************************************
#
# esegue aggiornamento
#
# ********************************************
srcscan ($src_dir);

print LOG_COPY "Nuovi file Copiati       = $copy_cnt \n";
print LOG_COPY "Vecchi file aggiornati   = $upd_cnt \n";
print LOG_COPY "Nuovi direttori creati   = $dir_cnt \n";
print LOG_COPY "Errori in copia          = $err_cnt \n";
print LOG_COPY "File pi recenti su TRG  = $recent_cnt \n";
print LOG_COPY "File non copiati         = $err_cnt \n";
print LOG_COPY "File ignorati            = $ignore_cnt \n";

# ********************************************
#
# esegue scansione per cancellazione orfani 
#
# ********************************************
inizializzadelscript();
trgscan($trg_dir);
concludedelscript();

# ********************************************
# ***
# *** chiude il log con i riepiloghi nel file LOG_ALL
# ***
# ********************************************
print LOG_ALL "..........................................\n";
print LOG_ALL "aggiornaPL_w $versione \n\n";
print LOG_ALL "inifile        = $inifile \n";
print LOG_ALL "inisection     = $inisection  \n";
print LOG_ALL "log_dir        = $log_dir  \n";
print LOG_ALL "log_name       = $log_name \n";
print LOG_ALL "base_dir       = $base_dir \n";
print LOG_ALL "trg_dir        = $trg_dir  \n";
print LOG_ALL "flg_email      = $flg_email\n";
print LOG_ALL "flg_ignoredata = $flg_ignoredata\n";
print LOG_ALL "flg_delete     = $flg_delete\n";
print LOG_ALL "flg_md5        = $flg_md5  \n";

print LOG_ALL "..........................................\n";
print LOG_ALL "Nuovi File copiati       = $copy_cnt \n";
print LOG_ALL "Vecchi File aggiornati   = $upd_cnt \n";
print LOG_ALL "File aggiornati * MD5    = $forceupd_cnt \n";
print LOG_ALL "Dir  cresti              = $dir_cnt \n";
print LOG_ALL "Errori in copia          = $err_cnt \n";
print LOG_ALL "File pi recenti su TRG  = $recent_cnt \n";
print LOG_ALL "File Ingorati            = $ignore_cnt \n";
print LOG_ALL "File da cancellare       = $delete_cnt \n";
print LOG_ALL "..........................................\n";

# ********************************************
# ***
# *** aggiorna il record del file statistiche
# ***
# ********************************************
my $stat_file    = $log_dir . '_statistica.csv';
my $disksize     = dfportable ($trg_dir);
my $data         = Date::Simple->new();

if ( testfile($stat_file, 0) == 0 ) {
    # non esiste..lo creo ed aggiungo la prima linea
    open LOG_STAT, ">> $stat_file"  or die "Non posso aprire $stat_file: $!";
    print LOG_STAT "data, copiati, aggiornati, aggiornati*MD5, dir creati, errori, ignorati, da cancellare, disco Gb liberi, disco Gb usati, destinazione backup\n";
}
else {
    # esiste...apro e basta
    open LOG_STAT, ">> $stat_file"  or die "Non posso aprire $stat_file: $!";
}
print LOG_STAT $data->day."/".$data->month."/".$data->year.", $copy_cnt, $upd_cnt, $forceupd_cnt, $dir_cnt, $err_cnt, $ignore_cnt, $delete_cnt," . int($disksize->{bavail}/1024000) .",". int($disksize->{bused}/1024000) .", $trg_dir \n";
close (LOG_STAT);

# --- chiude i log aperti
close (LOG_ALL);
close (LOG_ERR);
close (LOG_COPY);
close (LOG_DELSCRIPT);
close (LOG_BATSCRIPT);
close (LOG_IGNORE);
close (LOG_MD5);
close (LOG_DEBUG);

# --- rende il LOG_ALL e genera un PDF pi comodo per gli utenti
PdfConvert($all_file, $log_dir, $log_name);

if ( $flg_email > 0 ) {
    # --- compone il corpo del messaggio
    $bodymail = '';
    if ( $mail_txt gt '') {$bodymail = $mail_txt};
    $bodymail = "$bodymail\nFiles copiati:$copy_cnt \naggiornati:$upd_cnt \naggiornati*MD5:$forceupd_cnt \nignorati:$ignore_cnt \nDir Creati:$dir_cnt \nERRORI:$err_cnt \nDirettori obsoleti da rimuovere:$delete_cnt  File obsoleti da rimuovere:$delete_cnt\n============================================================\n\n";
    $bodymail = "$bodymail\n\nElenco Files Copiati/Aggiornati\n";
    $bodymail = leggi($copy_file, $bodymail);
    $bodymail = "$bodymail\n\nElenco Files Ignorati o in Errore\n";
    $bodymail = leggi($err_file, $bodymail);

    # --- inviare email con il file di log allegato
    if ($mail_cc gt '') {
        %mail = ( To      => $mail_to,
                  From    => $mail_from,
                  CC      => $mail_cc,
                  Subject => $mail_subject,
                  Message => "$bodymail" );
    }
    else {
        %mail = ( To      => $mail_to,
                  From    => $mail_from,
                  Subject => $mail_subject,
                  Message => "$bodymail" );
    }

    # --- se sono definiti mail_username e mail_password tento l'invio con autenticazione
    if ($mail_username gt '' && $mail_password gt '') {
        $mail{auth} = {user=>$mail_username, password=>$mail_password, method=>"DIGEST-MD5", required=>0 };
    }
    $mail{Smtp} = $mail_smtp;
    
    # autenticazione
    #  user => "username" password => "passwordset"
    #  method => se vuoto....li prova tutti, altrimenti se pieno usa quello: es "DIGEST-MD5"
    #  required => default nullo 0 prova ad inviare mail anche se l'autenticazione fallisce
    #              se assegnato 1: invia mail SOLO se l'autenticazione riesce
    #
    # $mail{auth} = {user=>"username", password=>"password", method=>"DIGEST-MD5", required=>0 };

    sendmail(%mail) or die $Mail::Sendmail::error;

    print "OK. sendmail:\n", $Mail::Sendmail::log;
}



#############################################
# 
# 
#  inizio Generazione file PDF
#
#
#############################################

sub PdfConvert{
	my $infile = $_[0];
	my $logdir = $_[1];
	my $mylogname = $_[2];
        
	my $portrait;
	my $page_height;
	my $page_width;
	my $page_count;
	my $line;
	my $conta = 0;
	my $pagina = 1;
	my $tmpkey = "";

	my $now = localtime();
	my @tvec = localtime();
	my $today = sprintf("%02d", $tvec[5] % 100 ) . '-' . sprintf("%02d", ++$tvec[4]) . '-' . sprintf("%02d", $tvec[3]);

	# define constants for the size of things
	use constant WIDTH     => 841;
	use constant HEIGHT    => 595;
	use constant FONT_SIZE => 8;
	use constant FONT_MINSIZE => 6;
	use constant FONT_MAXSIZE => 9;
	use constant FONT_HEIGHT => 7;
	use constant MAXLINE => 55;
	
	my $pdffile = $logdir . $mylogname . '-' .  $today . '.pdf';
	open (INFILE, "<$infile") || die "non esiste $infile, $!\n ";
	prFile($pdffile);

	prFont('Courier');
	prFontSize(FONT_SIZE);
	prCompress(1);
	# default: prMbox(0, 0, 595, 842);
	prMbox(0, 0, WIDTH, HEIGHT);
	prTouchUp(0); 

	PdfPageTop($pagina, $pdffile);

	while ($line = <INFILE>) {    
		my $y = HEIGHT-20-$conta*10;
		my $x = 5;

		my @fld = split /[|\*]/, $line;
		$tmpkey = $fld[0];
		chop($tmpkey);				# toglie l'ultimo carattere che  un \n
		
		#print "$fld[0] -> $fld[1]\n";

		prFont('Courier-Bold');
		prFontSize(FONT_MAXSIZE);
		if ( ($tmpkey eq MSG_ERROR) || ($tmpkey eq MSG_RECENT) ) {
			#red <- rosso 100% verde 0  blu 0
			prFontSize(FONT_MAXSIZE+1);
			prAdd("1.0 0.0 0.0 rg");
		}
		if ($tmpkey eq MSG_IGNORE) {
			# yellow <- full red, full green and no blue
			prFontSize(FONT_MAXSIZE+1);
			prAdd("0.835 0.765 0.0 rg");   
		}
		if ($tmpkey eq MSG_DELETE ) {
			# verde chiaro
			prFontSize(FONT_MAXSIZE+1);
			prAdd("0.0 0.604 0.016 rg");   
		}
		prText($x, $y, $fld[0]);
		prFont('Courier');
		if ( $line =~ /\*/ ) {
			if (length($fld[1]) >= 128) {
				prFontSize(FONT_MINSIZE);
			} else {
				prFontSize(FONT_SIZE);                    
			}
			prAdd("0.0 0.0 0.0 rg");   
			prText($x+80, $y, $fld[1]);
			# prText($x, $y, "$line");
		}
        
		if ($conta == MAXLINE) {
			prPage();
			$conta = 0;
			$pagina = $pagina + 1;
			PdfPageTop($pagina, $pdffile);
		} else {
			$conta = $conta +1;
		}
	}

	prEnd();
	close INFILE;
}

##########################################################################
#  To print before the end of the page
##########################################################################
sub PdfPageTop
{
	my $pagina = $_[0];
	my $pdffile = $_[1];
	
	prFont('Times-Roman');
	prFontSize(10);
	prText(500,HEIGHT-10,"File: $pdffile  Pagina: $pagina");
	prFont('Courier');
	prFontSize(FONT_SIZE);
}

#############################################
# 
# 
#  fine blocco Generazione file PDF
#
#
#############################################



# ---------------------------------------------------------------
# sub testfile
#   
#   riceve: nomefile, flg_quit
#           se non esiste nomefile ed flg_quit==1 ... allora interrompe
#   controlla se esiste il file
#   Se non esiste interrompe il programma
# ---------------------------------------------------------------
# controlla l'esistenza del file di test
sub testfile {
    my $nomefile = $_[0];
    my $flg_quit = $_[1];
    my $rval     = 1;
    
    if (!(-e $nomefile)) {
        $rval = 0;
        if ($flg_quit == 1) {
            # errore...termina
            die "Non esiste $nomefile";
        }
    }
    return $rval;
}    


# ---------------------------------------------------------------
#
# sub srcscan
#   riceve: nome del direttorio da leggere
#   rende:  ATTENZIONE IN QUESTA VERSIONE NON CONTROLLO ERRORI
#
# ---------------------------------------------------------------
sub srcscan  {

    my $scandir = $_[0];

    my @srclist;
    my $src;
    my $trg;
    my $ghost;
    my $ghostext;
    my $ghostnoext;
    my @infotrg;
    my @infosrc;
    my $msg;

    my $mode = 0777;           # modalit creazione nuovi file e direttori

    my $md5src;
    my $md5trg;
    
    my $deltam;
    my $deltasize;
    
    my $flg_dacopiare;
    my $flg_daaggiornare;
    my $flg_blacklist;
    my $flg_direttorio;

    my $nversioni;
    my $ghostversione;

    # --- incrementa il contatore recursione
	$recursivecall++;
	
    # monitor attivita'
    # print "$scandir\ncopiati:$copy_cnt  aggiornati:$upd_cnt  aggiornati*MD5:$forceupd_cnt  ignorati:$ignore_cnt  Dir Creati:$dir_cnt  ERRORI:$err_cnt\n\n";

    # usa il globbing
    # ATTENZIONE devo sostituire gli eventuali spazi nel direttorio con ? per un problema
    # con il funzionamento del glob
    $scandir =~ s/ /?/g;
    @srclist = glob (("$scandir". "*"));

    foreach $src (@srclist) {
        # --- in base al valore di $src determina il valore di $trg
        $trg = $src;
        $trg =~ s/$src_dir/$trg_dir/;
		
		if ( $flg_ghost == 1 ) {
			# --- in base al valore di $src determina il valore di $ghost
			$ghost = $src;
			$ghost =~ s/$src_dir/$ghost_dir/;
			if ( $debug == 1 ) {	
				print LOG_GHOST "ghost: $ghost\n";
			}
		}

		#
		# --- legge caratteristiche del singolo elemento
		#
		@infosrc = stat($src);
        if ( -d _) {
			$flg_direttorio=1;
			# -----------------------------------------------------------------------------------------------
			# --- indica un direttorio....escludo . e .. ed il direttorio del cestino di sistema per windows
			# -----------------------------------------------------------------------------------------------
			if ( ($src ne $src_dir.'.') && ($src ne $src_dir.'..') && ($src ne $src_dir."RECYCLER") && ($src ne $src_dir.'$Recycle.Bin') ) {
				#################################################################################################################################
				#
				# prima controllo il contenuto della dir black list
				#
				#   esempio: $dirblacklist = '(RECYCLER|System\sVolume\sInformation|tmp|temp)$';
				#
				#################################################################################################################################
				$flg_blacklist = chkregexpr( $src, $dirblacklist );

				# --- blocco debug
				if ($debug == 1) {
					print LOG_DEBUG "DEBUG DIR, flg_blacklist: $flg_blacklist, src: $src\n";
				}

				if (! $flg_blacklist) {
					# controlla se deve creare il direttorio sul disco di destinazione
					if (!(-e $trg)) {
						# non esiste...devo crearla
						mkdir ($trg, $mode);
						$dir_cnt ++;
					}
					# richiama la scansione ricorsivamente
					print RED "$src/\n";
					srcscan("$src/");
				}
			}
			# --- non servirebbe assegnare @infotrg...inserito per la caccia all'errore
			@infotrg = stat($trg);
		}
		else {
			$flg_direttorio = 0;
			# -----------------------------------------------------------------------------------------------
			# indica che  un file
			# -----------------------------------------------------------------------------------------------
			$msg = "$src ";
			# --- azzera i flag di controllo
			$flg_dacopiare = 0;
			$flg_daaggiornare = 0;
			# salta il file scandir.src e l'eventuale dbase miniature di windows
			if ( ($src ne $src_dir.'scandir.src') && ($src ne $src_dir.'Thumbs.db') ) {
				# -----------------------------------------------------------------
				# --- controlla se deve copiare il file sul disco di destinazione
				# -----------------------------------------------------------------
				if (!(-e $trg)) {
					# -----------------------------------------
					# --- non esiste....attiva il flag di copia
					# -----------------------------------------
					$flg_dacopiare = 1;
					$deltam = $infosrc[9];
					$deltasize = $infosrc[7];
				}
				else {
					# ------------------------------------------------------------------------------------------
					# --- esiste in destinazione....controlla se  da aggiornare con test data, ora e dimensione
					# ------------------------------------------------------------------------------------------
					@infotrg = stat($trg);
					# --- calcolo i delta date: deltam modifica creazione
					$deltam = $infosrc[9] - $infotrg[9];
					$deltasize = $infosrc[7] - $infotrg[7];
					# --- se richiesta la verifica MD5 e le dimensioni e la data modifica sono uguali
					if ( $flg_md5 && ($infotrg[7] == $infosrc[7]) && ($infotrg[9] == $infosrc[9]) ) {
						$md5src = md5sum($src);
						$md5trg = md5sum($trg);
						if ( $md5src != $md5trg ) {
							$flg_daaggiornare =1;
							# --- attiva LOG MD5
							print LOG_MD5 "src size:$infosrc[7] mtime: ".localtime($infosrc[9])."\tmd5src:$md5src \t$src\n";
							print LOG_MD5 "    size:$infotrg[7] mtime: ".localtime($infotrg[9])."\tmd5trg:$md5trg \t$trg\n\n";
						} 
					}
					# ---------
					# se e' attivo il flag di ingore data e le dimensioni sono diverse...
					# se le dimensioni sono diverse ed il sorgente  pi recente
					# se le dimensioni sono uguali ed il sorgente  piu recente
					# se  stato calcolato l'md5 dei due file e risulta diverso
					# ---------
					if (( $flg_ignoredata && $infotrg[7] != $infosrc[7] ) || ( $deltam > 0 ) ) {
						if ( $deltam > 0 ) { $msg = $msg . "*** Time ***"; }  
						if ( $infosrc[7] != $infotrg[7] ) { $msg = $msg . "*** Size ***"; }  
						$flg_daaggiornare = 1;    
					}
				}
		
				# ----------------------------------------------------------------------------------
				# fix per differenza di mtime in win32
				# ----------------------------------------------------------------------------------
				if ( $deltasize == 0 && $deltam == -1 ) {
					# --- aggiorna atime ed mtime del file di destinazione con quelli del file di origine
					#     sintassi utime (ati)
					utime($infosrc[8], $infosrc[9], $trg);   
				}
				if ( $deltasize != 0 && $deltam > -10 && $flg_dacopiare == 0 ) {
					# --- dimensioni diverse e file trg pi recente di max 9 secondi...aggiorna
					$flg_daaggiornare = 1;    
				}
				# ----------------------------------------------------------------------------------
				# END fix per differenza di mtime in win32
				# ----------------------------------------------------------------------------------
		
		
				#################################################################################################################################
				#
				# prima controllo il contenuto della black list
				#   blacklist:  -> .+                       tutti esclusi
				#               -> ^(alcuni|ed altri)       escluso quelli
				#               -> ^(*.bak|*.tbk|*.ntx)		escluso *.bak, *.tbk, *.ntx
				#
				# esempio: $fileblacklist = '(.exe|.dll)$';
				#################################################################################################################################
				$flg_blacklist = chkregexpr( $src, $fileblacklist );
		
				# --- blocco debug
				if ($debug == 1) {
				    print LOG_DEBUG "DEBUG File, flg_dacopiare: $flg_dacopiare, flg_daaggiornare: $flg_daaggiornare, flg_blacklist: $flg_blacklist, src: $src\n";
				}
			    								
				# ----------------------------------------------------------------------------------
				#
				# se  attivo il flag di copia o di aggiornamento procedo con la copia
				#
				# ----------------------------------------------------------------------------------
				if ( ( $flg_dacopiare == 1 || $flg_daaggiornare == 1 ) && ! $flg_blacklist ) {
					# 
					# --- scrive prima la info di debug
					#
					print BRIGHT_MAGENTA "\rworking on: $src";
					
					#
					# --- controllo versione
					#
					if ( $flg_ghost == 1 && $flg_daaggiornare == 1 ) {
						# controlla se deve creare il direttorio sul disco di destinazione
						if (!(-e $ghost)) {
							# non esiste...devo crearla
							make_path (dirname($ghost));
							print LOG_GHOST "creato dir, $ghost\n";
						}
						$ghostext=fullname_suffix($ghost);
						$ghostnoext=fullname_nosuffix($ghost);
						$nversioni = contaver ($ghost);
						$ghostversione = "$ghostnoext"."-#".sprintf("%03d", $nversioni+1)."#"."$ghostext";
						copy("$src", "$ghostversione");
						print LOG_GHOST "nuova versione, $src, $ghostnoext, $ghostversione, $ghostext\n";
					}
					
					#
					# --- esegue copia/aggiornamento del File 
					#
					if ( copy("$src", "$trg") ) {
						# --- aggiorna atime ed mtime del file di destinazione con quelli del file di origine
						utime($infosrc[8], $infosrc[9], $trg);

						# --- aggiorna i contatori
						if ( $flg_daaggiornare == 1) {
							$upd_cnt++;
							$upd_size += $infosrc[7];
							$msg = MSG_UPDATE;
						}
						if ( $flg_dacopiare == 1) {
							$copy_cnt++;
							$copy_size += $infosrc[7];
							$msg = MSG_COPY;
						}                
						print LOG_COPY "$msg, $deltam, $deltasize, $infosrc[7], " . fmtdata($infosrc[9]) . ", $src,";
						if ($flg_daaggiornare == 1) {
							print LOG_COPY "$infotrg[7], " . fmtdata($infotrg[9]) . ", $trg\n";
						}
						else {
							print LOG_COPY "\n";
						}
						print LOG_ALL  "$msg * $src\n";
					}
					else {
						$err_cnt ++;
						$msg = MSG_ERROR;
						# ------------
						# --- errore nella copia del file...segno sul log
						# ------------
						print LOG_ERR "ERROR, $deltam, $deltasize, $infosrc[7], " . fmtdata($infosrc[9]) . ", $src,";
						if ( $flg_daaggiornare == 1 ) {
							print LOG_ERR "$infotrg[7], " . fmtdata($infotrg[9]) . ", $trg\n";
						} else {
							print LOG_ERR "\n";
						}
						print LOG_ALL "$msg * $src\n";
					}
				}
				else {
					# 
					# --- file da ignorare
					# 
					# if ( $deltam < 0 ) {
					# eseguo il test sul -9 perch prima ho preso per identici i file con 10 sec di differenza
					if ( $deltam < -9 ) {
						$recent_cnt ++;
						$msg = MSG_RECENT;
						print LOG_RECENT "RECENTE, $deltam, $deltasize, $infosrc[7], " . fmtdata($infosrc[9]) . ", $src,";
						if ( ! $flg_blacklist ) {
							print LOG_RECENT "$infotrg[7], " . fmtdata($infotrg[9]) . ", $trg\n";
						} else {
							print LOG_RECENT "\n";
						}
						print LOG_ALL "$msg * $src\n";
					} else {
						$ignore_cnt ++;
						$msg = MSG_IGNORE;
						print LOG_IGNORE "IGNORA, $deltam, $deltasize, $infosrc[7], " . fmtdata($infosrc[9]) . ", $src,";
						if ( ! $flg_blacklist ) {
							print LOG_IGNORE "$infotrg[7], " . fmtdata($infotrg[9]) . ", $trg\n";
						} else {
							print LOG_IGNORE "\n";
						}
						print LOG_ALL "$msg * $src\n";
					}
				}
				
				#in base al flag...usa il colore
				# local $Term::ANSIColor::AUTORESET =1;
				print WHITE  "\rlevel:$recursivecall ";
				print YELLOW  "Cpy:$copy_cnt ";
				print GREEN   "Up:$upd_cnt ";
				print WHITE   "Ign:$ignore_cnt ";
				if ( $flg_blacklist == 1 )  {
					print RED "*** BLACKLIST *** $src";
				} else {
				    if ( $flg_daaggiornare == 1 ) {
						print GREEN "$src";
					} else {
						if ( $flg_dacopiare == 1 ) {
							print YELLOW "$src";
						} else {
							print WHITE "$src";
						}
				    }
				}
				print WHITE "\n";
				
				# --- ciclo di attesa se premo un carattere
				# my $ch;
				# $ch = ReadKey -1;
				# if ( defined ( $ch ) ) {
				#     print RED "Elaborazione sospesa...";
				#     print WHITE "attendere 60 secondo o premere ENTER per continuare\n";
				#     ReadKey ( 60 );
				# }
				#if (defined ($ch = ReadKey(-1)) ) {
				while ($STDIN->GetEvents()) {
					my @input;
					@input = $STDIN->Input();
					my ($eventType, $keyState, $keyCount, $keyCode, $scanCode, $keyValue, $keyFlags) = @input;
					
					if ($keyState == 1) {
						# input was waiting and it was $char
						print RED "Elaborazione sospesa...";
						print WHITE "attendere 15 secondi o premere ENTER per continuare\n";
						ReadKey (15);
					}
				}
			}
		}
	}
	
	# --- decrementa il contatore ricursione
	$recursivecall--;
	
    return 0;
}

# ---------------------------------------------------------------
# sub che formatta un campo data per i log
#   riceve: una data
#   rende:  la stringa formattata da scrivere nel log
# ---------------------------------------------------------------
sub fmtdata {
	my $data = $_[0];
	my $rval;
	my $tm;
	
	$tm = localtime($data);
	
	$rval = strftime( "%e/%m/%Y %H.%M.%S", localtime($data) );
	
	#$rval = sprintf("%02d/%02d/%04d %02d.%02d.%02d", $tm->mday, ($tm->mon)+1, $tm->year+1900, $tm->hour, $tm->min, $tm->sec);
		
	# --- questa rende la data nella forma dscrittiva ma scomoda
	#$rval = $tm;
	return $rval;
}


# ---------------------------------------------------------------
# sub infofile
#   riceve: nome del direttorio o de file
#   rende:  le informazioni sul file/direttorio come hash
# ---------------------------------------------------------------
sub infofile {

    #  0 dev      device number of filesystem
    #  1 ino      inode number
    #  2 mode     file mode  (type and permissions)
    #  3 nlink    number of (hard) links to the file
    #  4 uid      numeric user ID of file owner
    #  5 gid      numeric group ID of file owner
    #  6 rdev     the device identifier (special files only)
    #  7 size     total size of file, in bytes
    #  8 atime    last access time in seconds since the epoch
    #  9 mtime    last modify time in seconds since the epoch
    # 10 ctime    inode change time in seconds since the epoch (*)
    # 11 blksize  preferred block size for file system I/O 
    # 12 blocks   actual number of blocks allocated

    my $searchfile = $_[0];

    my %rval;
    my @info;

    my $name;
    my $path;
    my $ext;
    my $isdir;
    my $ifexist;
    
    @info = stat( $searchfile );

    if ( -d _) {
        #  un direttorio
        $isdir = 1;
        $name = "";
        $ext = "";
        $path = $searchfile;
    }  else {
        #  un file
        $isdir = 0;

        # richiede use File::Basename;
        ($name, $path, $ext ) = fileparse( $searchfile, "\.[^.]*");
    }

    $ifexist =  ( -e _) ? 1 : 0; 

    # debug vari
    #    print  "Leggibile\n" if -r _;
    #    print  "Scrivibile\n" if -w _;
    #    print  "Eseguibile\n" if -x _;
    #    print  "Setuid\n" if -u _;
    #    print  "Setgid\n" if -g _;
    #    print  "Sticky\n" if -k _;
    #    print  "Testo\n" if -T _;
    #    print  "File binario\n" if -B _;

    %rval = (
        'dev'      => $info[0],
        'ino'      => $info[1],
        'mode'     => $info[2],
        'nlink'    => $info[3],
        'uid'      => $info[4],
        'gid'      => $info[5],
        'rdev'     => $info[6],
        'size'     => $info[7],
        'atime'    => $info[8],
        'mtime'    => $info[9],
        'ctime'    => $info[10],
        'blksize'  => $info[11],
        'blocks'   => $info[12],
        'filename' => $name . $ext,
        'basename' => $name,
        'ext'      => $ext,
        'fullpath' => $path,
        'fullname' => $searchfile,
        'isdir'    => $isdir,
        'exist'    => $ifexist
    );
    
    return %rval;
}



# ---------------------------------------------------------------
# sub chkregexpr
#   
#   riceve: stringa, regexpr
# valuta regexpr in base al contenuto di stringa
# se l'espressione regolare  soddsftatta ritorna la parte di stringa
# che ha soddisfatto l'espressione regolare.
# altrimenti rende una strnga vuota!
# ---------------------------------------------------------------

sub chkregexpr {
    my $stringa = $_[0];
    my $regexpr = $_[1];
    my $rval = 0;
    
    # da un manuale
    # Variable Interpolation and the "o" Modifier
    # $codon = '.{3}';
    # @frame1 = $sequence =~ /($codon)/og;
	
    # la lettera "i" alla fine serve per ignorare maiuscole/minuscole
    if ($stringa =~ /$regexpr/i) {
        $rval = 1;
    }

	if ( $debug == 1 ) {	
		print LOG_DEBUG "DEBUG CHKREGEXP, Stringa:$stringa Regexpr:$regexpr Rval:$rval\n";
	}
    return $rval;
}


# ------------------------------------------------------
# sub md5sum
#   riceve: nome del file
#   rende:  valore calcolato per hash MD5
# ------------------------------------------------------

sub md5sum
{
    my $file = $_[0];
    my $rval = 0;

    # apre file in binmode
    open(FILE, $file) or die "Can't open '$file': $!";
    binmode(FILE);

    #calcola MD5
    $rval = Digest::MD5->new->addfile(*FILE)->hexdigest;
    close(FILE);
    return $rval;
}


# -------------------------------------------------------
#
# sub leggi()
#       riceve: nome del file da leggere
#       rende:  array con le righe lette
#
# --------------------------------------------------------
sub leggi
{
    my $infile = $_[0];
    my $bodymail = $_[1];
    my @righe;
    my $righe;

    # legge il file
    open INFILE,    "< $infile"  or die "Non posso aprire $infile:  $!";
    @righe = <INFILE>;
    close (INFILE);

    # lo aggiunge alla stringa
    foreach $righe (@righe)
    {
    $bodymail = "$bodymail $righe";
    }

    return $bodymail;
}

# ---------------------------------------------------------------
# sub trgscan
#   riceve: nome del direttorio da leggere
#   rende:  ATTENZIONE IN QUESTA VERSIONE NON CONTROLLO ERRORI
# ---------------------------------------------------------------
sub trgscan  {

    my $scandir = $_[0];

    my @trglist;
    my $trg;
    my $src;
    my @infotrg;
    my @infosrc;
    my $msg;

    # monitor attivit
    print "da cancellare:$delete_cnt  $scandir\n";

    # usa il globbing
    # ATTENZIONE devo sostituire gli eventuali spazi nel direttorio con ? per un problema
    # con il funzionamento del glob
    $scandir =~ s/ /?/g;
    @trglist = glob (("$scandir". "*"));

    foreach $trg (@trglist)
    {
        # in base al valore di $trg determina il valore di $src
        $src = $trg;
        $src =~ s/$trg_dir/$src_dir/;

        # legge caratteristiche del singolo elemento
        @infotrg = stat($trg);

        if ( -d _)         
        {
            # indica un direttorio....salta il direttorio corrente, il padre ed il direttorio di sistema
            if ( ($trg ne $trg_dir.'.') && ($trg ne $trg_dir.'..') && ($trg ne $trg_dir."RECYCLER") )
            {
                # escludo il direttorio . e .. controlla se esiste il direttorio sul master
                if (-e $src)
                {
                    # esiste il direttorio...verifico ricorsivamente i file
                    trgscan("$trg/");
                }
                else
                {
                    # non esiste il direttorio segnalo il direttorio come da cancellare
                    $delete_cnt = $delete_cnt + cancelladir("$trg");
                }
            }
        }
        else
        {
            # indica che  un file
            $msg = "$trg ";

            if ( ($trg ne $trg_dir.'scandir.trg') && ($trg ne $trg_dir.'Thumbs.db') )
            {
               # controlla se deve cancellare il file
               if (!(-e $src))
               {
                  # non esiste....lo cancella
                  $delete_cnt =$delete_cnt + cancellafile("$trg");
               }

               # in base al messaggio fa le segnalazioni
               $msg = $msg . "\n";
            }
        }
    }
    
    return 0;
}

# ---------------------------------------------------------------
# sub contaver
#   riceve: nome del file di cui cercare le versioni
#   rende:  il numero di versioni trovate
# ---------------------------------------------------------------
sub contaver  {

    my $file = $_[0];

    my $fileext;
    my $filenoext;
    
    my @filelist;
    my $msg;
    my $item;
    my $conta =0;

    # usa il globbing
    # ATTENZIONE devo sostituire gli eventuali spazi nel direttorio con ? per un problema
    # con il funzionamento del glob
    $file =~ s/ /?/g;
    $fileext=fullname_suffix($file);
    $filenoext=fullname_nosuffix($file);

    @filelist = glob (($filenoext."-#???#".$fileext));

    foreach $item (@filelist)
    {
	$conta++
    }
    # monitor attivit
    if ($flg_ghost == 1) {
		print CYAN "item versione:$conta $file\n";
		if ( $debug == 1 ) {
			print DEBUG "DEBUG VERSION, versioni:$conta, $file)\n";
		}
    }
    return $conta;
}


# ------------------------------------------------------
#  sub cancellafile()
#    riceve: nome file da cancellare
#    rende:  1 se inserito riga di cancellazione file
#            0 se non inserita
# ------------------------------------------------------
sub cancellafile
{
    my $dacancellare = $_[0];
    my $rval = 1;
    my $delmsg = '';

    # se e' un file....crea script di cancellazione il perl
    $dacancellare =~ s/\'/\\\'/g;
    $delmsg = 'delfile (\'' . $dacancellare . "\');\n";            
    print LOG_DELSCRIPT "$delmsg";
	# ... ed il bat per il dos
    $delmsg = "del \"" . $dacancellare . "\"\n";
	$delmsg =~ tr{/}{\\};
	print LOG_BATSCRIPT "$delmsg";
	print LOG_ALL MSG_DELETE . " *$dacancellare\n";

    if ($flg_delete == 1)
    {
        # se abilitata cancellazione automatica....cancello
        delfile ($dacancellare);    
    }
	return $rval;
}


# ************************************************************
# *** sub cancelladir
# *** 		riceve: nome direttorio da cancellare
# *** 		rende:	n se inserito n-righe di cancellazione file
# ***				0 se non inserita
# ************************************************************
sub cancelladir
{
    # my $dacancellare = @_[0];
    my $dacancellare = $_[0];
    my @files ;
    my $files = '';
    my $rval = 1;
    my @info;
    my $delmsg = '';


    # usa il globbing
    # ATTENZIONE devo sostituire gli eventuali spazi nel direttorio con ? per un problema
    # con il funzionamento del glob
    $files = $dacancellare;
    $files =~ s/ /?/g;
    @files = glob (("$files". "/*"));

    foreach $files (@files)
    {
        # test esclusione direttorio corrente e direttorio padre
        if ($files ne '.' && $files ne '..' )
        {
            # escludo il direttorio punto e puntopunto 
            @info = stat($files);
            if ( -d _)         
            {
                #  un direttorio...lo verifico ricorsivamente i file
                trgscan("$files/");
            }
            else
            {
                # e' un file
                $rval += cancellafile ($files);
            }
        }
    }

    # dopo avere svuotato il direttorio.....lo elimina
    $dacancellare =~ s/\'/\\\'/g;
    #$delmsg = "deldir  (\'" . $dacancellare . "\');\n";
    $delmsg = "rmtree  (\'" . $dacancellare . "\');\n";
    print LOG_DELSCRIPT "$delmsg";
	# ...per il BAT
    $delmsg = "rmdir \"" . $dacancellare . "\"\n";
	$delmsg =~ tr{/}{\\};
    print LOG_BATSCRIPT "$delmsg";
	
    print LOG_ALL MSG_DELETE . "*$dacancellare\n";

    if ($flg_delete == 1)
    {
        # se abilitata cancellazione automatica....cancello
        rmtree ($dacancellare);    
    }
    
    return $rval;
}


# ************************************************************
# ***
# *** inizializza lo script di delete per renderlo usabile
# ***
# ************************************************************
sub inizializzadelscript
{

    # inizializzo lo script
    print LOG_DELSCRIPT '#!c:/perl/bin/perl -w' . "\n\n";
    print LOG_DELSCRIPT '# (c) Andrea sommaruga - http://sommaruga.stcom.com' . "\n";
    print LOG_DELSCRIPT "\n\n";
    print LOG_DELSCRIPT "use File::Path\n\n";
    print LOG_DELSCRIPT 'my $conta = 0;' . "\n";

	# per il BAT
	print LOG_BATSCRIPT "\@echo DelScript\n";
	print LOG_BATSCRIPT "pause\n";

    return 1;
}

# ************************************************************
# ***
# *** conclude lo script di delete per renderlo usabile
# ***
# ************************************************************
sub concludedelscript
{

    # come prima cosa chiude lo script generale...quindi crea le due funzioni
    print LOG_DELSCRIPT 'print "*** CANCELLATI: $conta\n";' . "\n";
    print LOG_DELSCRIPT "\n\n";
    
    # crea la funzione cancellafile
    print LOG_DELSCRIPT 'sub delfile' . "\n";
    print LOG_DELSCRIPT '{' . "\n";
    print LOG_DELSCRIPT '  my $filedacancellare = $_[0];' . "\n";
    print LOG_DELSCRIPT '  my $rval = 1;' . "\n";
    print LOG_DELSCRIPT '  if (-e $filedacancellare)' . "\n";
    print LOG_DELSCRIPT '  {'. "\n";
    print LOG_DELSCRIPT '    $rval = unlink $filedacancellare;' . "\n";
    print LOG_DELSCRIPT '    if ($rval != 1)' . "\n";
    print LOG_DELSCRIPT '    {' . "\n";
    print LOG_DELSCRIPT '      print "**** ERR DELETE FILE ****: $filedacancellare\n";'. "\n";
    print LOG_DELSCRIPT '    }' . "\n";
    print LOG_DELSCRIPT '      else' . "\n";
    print LOG_DELSCRIPT '    {' . "\n";
    print LOG_DELSCRIPT '      print "Cancellati:$conta - $filedacancellare\n";'. "\n";
    print LOG_DELSCRIPT '      $conta++;' . "\n";
    print LOG_DELSCRIPT '    }' . "\n";
    print LOG_DELSCRIPT '  }' . "\n";
    print LOG_DELSCRIPT '  return $rval;' . "\n";
    print LOG_DELSCRIPT '}'. "\n";

    # crea la funzione cancelladir
    print LOG_DELSCRIPT 'sub deldir' . "\n";
    print LOG_DELSCRIPT '{'. "\n";
    print LOG_DELSCRIPT '  my $DIRdacancellare = $_[0];'. "\n";
    print LOG_DELSCRIPT '  my $rval = 1;'. "\n";
    print LOG_DELSCRIPT '  if (-e $DIRdacancellare)' . "\n";
    print LOG_DELSCRIPT '  {'. "\n";
    print LOG_DELSCRIPT '    $rval = rmdir $DIRdacancellare;'. "\n";
    print LOG_DELSCRIPT '    if ($rval != 1)'. "\n";
    print LOG_DELSCRIPT '    {'. "\n";
    print LOG_DELSCRIPT '      print "ERR DELETE DIR: $DIRdacancellare\n";' . "\n";
    print LOG_DELSCRIPT '    }'. "\n";
    print LOG_DELSCRIPT '  }'. "\n";
    print LOG_DELSCRIPT '  return $rval;'. "\n";
    print LOG_DELSCRIPT '}'. "\n";
    
	# per il BAT
	print LOG_BATSCRIPT "pause\n";

    return 1;
}

# ------------------------------------------------------
# sub delfile()
#   riceve: nome file da cancellare
# ------------------------------------------------------
sub delfile
{
    my $filedacancellare = $_[0];
    my $rval = 1;
    if (-e $filedacancellare)
    {
        $rval = unlink $filedacancellare;
        if ($rval != 1)
        {
            print "**** ERR DELETE FILE ****: $filedacancellare\n";
        }
    }
return $rval;
}


# ------------------------------------------------------
# sub deldir()
#   riceve: nome direttorio da cancellare
# ------------------------------------------------------
sub deldir
{
  my $DIRdacancellare = $_[0];
  my $rval = 1;
  if (-e $DIRdacancellare)
  {
    $rval = rmdir $DIRdacancellare;
    if ($rval != 1)
    {
      print "ERR DELETE DIR: $DIRdacancellare\n";
    }
  }
  return $rval;
}

# eof AggiornaPL_w.pl